#!/usr/bin/env ruby
require 'tk'

TkLabel.new(:text=>'Please click a left or right button on the canvas.').pack

c = Tk::Canvas.new(nil, :width=>600, :height=>400, :relief=>:sunken, 
                   :borderwidth=>3).pack(:fill=>:both, :expand=>true)

f = TkFont.new('Helvetica -16')
def f.scale(rate)
  @fontsize ||= self.actual_hash['size'].to_f
  sz = (@fontsize *= rate).to_i
  self.size = (sz < 2)? 2: sz
end

tag = TkcTag.new(c)
TkcRectangle.new(c, 200,200, 300,300, :tags=>tag)
TkcLine.new(c, 200,150, 350,300, :tags=>tag)
TkcOval.new(c, 250,150, 400,250, :tags=>tag)
TkcText.new(c, 350,200, :text=>'text object', :font=>f, :tags=>tag)
TkcText.new(c, 200,250, :text=>'TEXT OBJ 2', :font=>f, :tags=>tag)

# old style to define bindings
c.bind('1', proc{|x,y| tag.scale(x, y, 1.25, 1.25); f.scale(1.25)}, '%x %y')
#c.bind('3', proc{|x,y| tag.scale(x, y, 1.25, 1.25); f.scale(1.25)}, '%x %y')

# recent style to define bindings
#c.bind('1', :x, :y){|x,y| tag.scale(x, y, 0.8, 0.8); f.scale(0.8)}
c.bind('3', :x, :y){|x,y| tag.scale(x, y, 0.8,  0.8); f.scale(0.8)}

Tk.mainloop
